/*
 * PrototipoImportacao1de3.java
 */
package br.com.unimed.importador.visao;


import br.com.unimed.importador.cadastro.mascara_de_arquivo.visao.FrmMascaraManutencaoDeArquivo;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.visao.FrmMascaraManutencaoDeRegistro;
import br.com.unimed.importador.dominio.ControladorDeImportacao;
import br.com.unimed.importador.dominio.MascaraDeCampo;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 * The application's main frame.
 */
public class Importacao2de4 extends FrameView {

    private SingleFrameApplication app;
    private static FrameView _instance = null;
    private static JTextField[] jTextField = null;
    private static ControladorDeImportacao controlador;
    private static JLabel[] jLabel = null;// </editor-fold>
    private static List<MascaraDeCampo> parametrosDoUsuario;

    public static FrameView getInstance(SingleFrameApplication app) {
        if (_instance == null) {
            _instance = new Importacao2de4(app);
        } else {
            loadParameters();
        }

        return _instance;
    }

    private Importacao2de4(SingleFrameApplication app) {
        super(app);
        this.app = app;
        initComponents();
           
        /* desaloca a GUI e libera recursos quando sair */
        getFrame().setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        loadParameters();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
            }
        });

        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0;
                i < busyIcons.length;
                i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());

        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {

            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }

                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();

                } else if ("message".equals(propertyName)) {
                    //String text = (String) (evt.getNewValue());
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    //int value = (Integer) (evt.getNewValue());
                }
            }
        });

    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = Main.getApplication().getMainFrame();
            aboutBox = new AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);


        }
        Main.getApplication().show(aboutBox);


    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jLabel22 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanelParametro = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButtonVoltar = new javax.swing.JButton();
        jButtonAvancar = new javax.swing.JButton();
        jButtonFinalizar = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();
        jButtonAjuda = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenuCadastro = new javax.swing.JMenu();
        jMenuItemMascaraDeArquivo = new javax.swing.JMenuItem();
        jMenuMascaraDeRegistro = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        jPanel3 = new javax.swing.JPanel();

        mainPanel.setMaximumSize(new java.awt.Dimension(2000, 2000));
        mainPanel.setMinimumSize(new java.awt.Dimension(923, 421));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(923, 421));
        mainPanel.setLayout(null);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(br.com.unimed.importador.visao.Main.class).getContext().getResourceMap(Importacao2de4.class);
        jLabel22.setFont(resourceMap.getFont("jLabel22.font")); // NOI18N
        jLabel22.setText(resourceMap.getString("jLabel22.text")); // NOI18N
        jLabel22.setName("jLabel22"); // NOI18N
        mainPanel.add(jLabel22);
        jLabel22.setBounds(330, 50, 140, 15);

        jPanel5.setBackground(resourceMap.getColor("jPanel5.background")); // NOI18N
        jPanel5.setName("jPanel5"); // NOI18N

        jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel16.setIcon(resourceMap.getIcon("jLabel16.icon")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        jLabel12.setFont(resourceMap.getFont("jLabel12.font")); // NOI18N
        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        jLabel19.setFont(resourceMap.getFont("jLabel19.font")); // NOI18N
        jLabel19.setText(resourceMap.getString("jLabel19.text")); // NOI18N
        jLabel19.setName("jLabel19"); // NOI18N

        jLabel20.setText(resourceMap.getString("jLabel20.text")); // NOI18N
        jLabel20.setName("jLabel20"); // NOI18N

        jLabel21.setText(resourceMap.getString("jLabel21.text")); // NOI18N
        jLabel21.setName("jLabel21"); // NOI18N

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel12)
                            .addComponent(jLabel19)
                            .addComponent(jLabel20, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel21))
                        .addContainerGap(24, Short.MAX_VALUE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel16, javax.swing.GroupLayout.DEFAULT_SIZE, 274, Short.MAX_VALUE)
                        .addGap(24, 24, 24))))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(61, 61, 61)
                .addComponent(jLabel12)
                .addGap(6, 6, 6)
                .addComponent(jLabel19)
                .addGap(6, 6, 6)
                .addComponent(jLabel20)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel21)
                .addGap(83, 83, 83)
                .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(117, Short.MAX_VALUE))
        );

        mainPanel.add(jPanel5);
        jPanel5.setBounds(0, 0, 310, 430);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jPanelParametro.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelParametro.setName("jPanelParametro"); // NOI18N

        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setName("jLabel2"); // NOI18N

        javax.swing.GroupLayout jPanelParametroLayout = new javax.swing.GroupLayout(jPanelParametro);
        jPanelParametro.setLayout(jPanelParametroLayout);
        jPanelParametroLayout.setHorizontalGroup(
            jPanelParametroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelParametroLayout.createSequentialGroup()
                .addGap(50, 50, 50)
                .addGroup(jPanelParametroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap(537, Short.MAX_VALUE))
        );
        jPanelParametroLayout.setVerticalGroup(
            jPanelParametroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelParametroLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(33, 33, 33)
                .addComponent(jLabel2)
                .addContainerGap(213, Short.MAX_VALUE))
        );

        jScrollPane1.setViewportView(jPanelParametro);

        mainPanel.add(jScrollPane1);
        jScrollPane1.setBounds(330, 70, 570, 270);

        jButtonVoltar.setIcon(resourceMap.getIcon("jButtonVoltar.icon")); // NOI18N
        jButtonVoltar.setText(resourceMap.getString("jButtonVoltar.text")); // NOI18N
        jButtonVoltar.setName("jButtonVoltar"); // NOI18N
        jButtonVoltar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVoltarActionPerformed(evt);
            }
        });
        mainPanel.add(jButtonVoltar);
        jButtonVoltar.setBounds(330, 370, 99, 40);

        jButtonAvancar.setIcon(resourceMap.getIcon("jButtonAvancar.icon")); // NOI18N
        jButtonAvancar.setText(resourceMap.getString("jButtonAvancar.text")); // NOI18N
        jButtonAvancar.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonAvancar.setName("jButtonAvancar"); // NOI18N
        jButtonAvancar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAvancarActionPerformed(evt);
            }
        });
        mainPanel.add(jButtonAvancar);
        jButtonAvancar.setBounds(440, 370, 99, 40);

        jButtonFinalizar.setIcon(resourceMap.getIcon("jButtonFinalizar.icon")); // NOI18N
        jButtonFinalizar.setText(resourceMap.getString("jButtonFinalizar.text")); // NOI18N
        jButtonFinalizar.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonFinalizar.setName("jButtonFinalizar"); // NOI18N
        jButtonFinalizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFinalizarActionPerformed(evt);
            }
        });
        mainPanel.add(jButtonFinalizar);
        jButtonFinalizar.setBounds(580, 370, 99, 40);
        jButtonFinalizar.getAccessibleContext().setAccessibleName(resourceMap.getString("jButtonFinalizar.AccessibleContext.accessibleName")); // NOI18N

        jButtonCancelar.setIcon(resourceMap.getIcon("jButtonCancelar.icon")); // NOI18N
        jButtonCancelar.setText(resourceMap.getString("jButtonCancelar.text")); // NOI18N
        jButtonCancelar.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonCancelar.setName("jButtonCancelar"); // NOI18N
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });
        mainPanel.add(jButtonCancelar);
        jButtonCancelar.setBounds(690, 370, 99, 40);

        jButtonAjuda.setIcon(resourceMap.getIcon("jButtonAjuda.icon")); // NOI18N
        jButtonAjuda.setText(resourceMap.getString("jButtonAjuda.text")); // NOI18N
        jButtonAjuda.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonAjuda.setName("jButtonAjuda"); // NOI18N
        jButtonAjuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAjudaActionPerformed(evt);
            }
        });
        mainPanel.add(jButtonAjuda);
        jButtonAjuda.setBounds(800, 370, 99, 40);

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(br.com.unimed.importador.visao.Main.class).getContext().getActionMap(Importacao2de4.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setIcon(resourceMap.getIcon("exitMenuItem.icon")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenuCadastro.setName("jMenuCadastro"); // NOI18N

        jMenuItemMascaraDeArquivo.setText(resourceMap.getString("jMenuItemMascaraDeArquivo.text")); // NOI18N
        jMenuItemMascaraDeArquivo.setName("jMenuItemMascaraDeArquivo"); // NOI18N
        jMenuItemMascaraDeArquivo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMascaraDeArquivoActionPerformed(evt);
            }
        });
        jMenuCadastro.add(jMenuItemMascaraDeArquivo);

        jMenuMascaraDeRegistro.setText(resourceMap.getString("jMenuMascaraDeRegistro.text")); // NOI18N
        jMenuMascaraDeRegistro.setName("jMenuMascaraDeRegistro"); // NOI18N
        jMenuMascaraDeRegistro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuMascaraDeRegistroActionPerformed(evt);
            }
        });
        jMenuCadastro.add(jMenuMascaraDeRegistro);

        menuBar.add(jMenuCadastro);

        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setIcon(resourceMap.getIcon("aboutMenuItem.icon")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        jPanel3.setName("jPanel3"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonVoltarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVoltarActionPerformed
        // TODO add your handling code here:
        Main.getApplication().hide(Importacao2de4.getInstance(app));
        Main.getApplication().show(Importacao1de4.getInstance(app));

    }//GEN-LAST:event_jButtonVoltarActionPerformed

    private void jButtonAvancarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAvancarActionPerformed
        // TODO add your handling code here:

        parametrosDoUsuario = controlador.obterParametrosDoUsuario(Importacao1de4.getTipoArquivoOrigem(),
                Integer.parseInt(Importacao1de4.getVersao()));

        /* preenche os parametros */
        int i = 0;
        for (JTextField chave : Importacao2de4.getParametros()) {
            parametrosDoUsuario.get(i).setValor(chave.getText().toUpperCase());
            i += 1;
        }

        Main.getApplication().show(Importacao3de4.getInstance(app));
        Main.getApplication().hide(Importacao2de4.getInstance(app));
    }//GEN-LAST:event_jButtonAvancarActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        // TODO add your handling code here:
        Main.getApplication().hide(Importacao2de4.getInstance(app));
        Main.getApplication().show(Importacao1de4.getInstance(app));
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    public static JTextField[] getParametros() {
        return jTextField;
    }

    /**
     * @return the jTextField
     */
    public static JTextField[] getjTextField() {
        return jTextField;
    }

    /**
     * @return the jLabel
     */
    public static JLabel[] getjLabel() {
        return jLabel;
    }

    public static List<MascaraDeCampo> getObterParametrosUsuario() {
        return parametrosDoUsuario;
    }

    public static void setObterParametrosUsuario(List <MascaraDeCampo> param) {
        parametrosDoUsuario = param;
    }

    public static void loadParameters() {

        /* local variables */
        int x = 10;
        int y = 10;
        /* iniciliar o controlador */
        controlador = ControladorDeImportacao.getInstance();
        List<MascaraDeCampo> v = new ArrayList<MascaraDeCampo>();

        v = controlador.obterParametrosDoUsuario(Importacao1de4.getTipoArquivoOrigem(),
                Integer.parseInt(Importacao1de4.getVersao()));

         jButtonFinalizar.setEnabled(true);

        if (!v.isEmpty()) {


            /* cria vector de JTextFields e JLabels em tempo de execução */
            if (jTextField == null) {
                jTextField = new JTextField[v.size()];
            } else {
                /* existem dados */
                return;
            }

            if (jLabel == null) {
                jLabel = new JLabel[v.size()];
            }


            
            int ii = 0;

            for (MascaraDeCampo e: v)  {
                
                jLabel[ii] = new JLabel(e.getCodigo().trim() + ":");
                jLabel[ii].setBounds(x, y, 150, 25);

                jTextField[ii] = new JTextField();
                jTextField[ii].setName(e.getCodigo());

                jTextField[ii].setBounds(x + jLabel[ii].getWidth(), y, e.getTamanho() * 25, 25);

                y = y + jTextField[ii].getHeight() + 10;

                jPanelParametro.add(jLabel[ii]);
                jPanelParametro.add(jTextField[ii]);

                ii++;

            }

            jPanelParametro.updateUI();
           
        }
    }

    private void jButtonFinalizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFinalizarActionPerformed
        // TODO add your handling code here:

        parametrosDoUsuario = controlador.obterParametrosDoUsuario(Importacao1de4.getTipoArquivoOrigem(),
                Integer.parseInt(Importacao1de4.getVersao()));

        /* preenche os parametros */
        int i = 0;
        for (JTextField chave : Importacao2de4.getParametros()) {

            if (chave.getText().length() == 0) {
                JOptionPane.showMessageDialog(null, "Preencha os parametros", "Informe"
                        + "Dados", JOptionPane.ERROR_MESSAGE);
                return;
            }

            
            parametrosDoUsuario.get(i).setValor(chave.getText().toUpperCase());
            i += 1;
        }

        jButtonFinalizar.setEnabled(false);
        controlador.setParent(getComponent());
        controlador.ImportarArquivo(Importacao1de4.getArquivoOrigem(), parametrosDoUsuario, Importacao3de4.isRemoverRegistro());

       /* delete o controlador acima e descomente o controlador abaixo para utilizar versão */

        // controlador.ImportarArquivo(Importacao1de4.getArquivoOrigem(), Importacao1de4.getVersao(),
        //        Importacao1de4.getTipoArquivoOrigem(), "", "", parametrosDoUsuario, Importacao3de4.isRemoverRegistro());

    }//GEN-LAST:event_jButtonFinalizarActionPerformed

    private void jMenuItemMascaraDeArquivoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMascaraDeArquivoActionPerformed
        // TODO add your handling code here:
        FrmMascaraManutencaoDeArquivo manutencaoDeArquivo =
                new FrmMascaraManutencaoDeArquivo();

        manutencaoDeArquivo.setVisible(true);
}//GEN-LAST:event_jMenuItemMascaraDeArquivoActionPerformed

    private void jMenuMascaraDeRegistroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuMascaraDeRegistroActionPerformed
        // TODO add your handling code here:
        FrmMascaraManutencaoDeRegistro manutencaoDeRegistro =
                new FrmMascaraManutencaoDeRegistro();
}//GEN-LAST:event_jMenuMascaraDeRegistroActionPerformed

    private void jButtonAjudaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAjudaActionPerformed
        // TODO add your handling code here:
         ImportacaoHelp.getInstance().openHelp();
    }//GEN-LAST:event_jButtonAjudaActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAjuda;
    private javax.swing.JButton jButtonAvancar;
    private javax.swing.JButton jButtonCancelar;
    private static javax.swing.JButton jButtonFinalizar;
    private javax.swing.JButton jButtonVoltar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JMenu jMenuCadastro;
    private javax.swing.JMenuItem jMenuItemMascaraDeArquivo;
    private javax.swing.JMenuItem jMenuMascaraDeRegistro;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private static javax.swing.JPanel jPanelParametro;
    private static javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    // End of variables declaration//GEN-END:variables
    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;
    private JDialog aboutBox;
}
